/**
 * @mainpage Birch Driver and Compiler
 *
 * Birch is a compiled, imperative, object-oriented, and probabilistic
 * programming language. The latter is its primary research concern. This
 * documentation is for the Birch compiler and is only of interest to its
 * developers. Users will be more interested in the standard library,
 * documented separately.
 *
 * The @em Modules page is a good place to start.
 *
 * @defgroup common Common
 * Abstract syntax tree common components, typically inherited by other node
 * classes.
 *
 * @defgroup expression Expressions
 * Abstract syntax tree node classes for expressions.
 *
 * @defgroup statement Statements
 * Abstract syntax tree node classes for statements.
 *
 * @defgroup type Types
 * Abstract syntax tree node classes for types.
 *
 * @defgroup visitor Visitors
 * Visitors over abstract syntax trees.
 *
 * @defgroup io Code generation
 * Code generation.
 *
 * @defgroup exception Exceptions
 * Exceptions.
 */
